LeetCode-198&213.House Robber

来源:互联网 发布:医学软件大全 编辑:程序博客网 时间:2024/05/17 07:58

198 https://leetcode.com/problems/house-robber/

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

显然本题应该是用动态规划来解,但是思路有多种

思路1:

因为每一个房间都有两种选择,rob和unrob

如果rob,则当前rob=当前val+上一房间unrob情况下的最大值

如果unrob,则当前unrob=之前的所有最大值

维护四个变量

public int Rob(int[] nums)     {        int n = nums.Length;        if (n == 0)            return 0;        int rob = nums[0], unrob = 0, maxRob = nums[0], maxUnrob = 0;        for (int i = 1; i < n; i++)        {            rob = nums[i] + maxUnrob;            unrob = maxRob;            maxRob = Math.Max(maxRob, rob);            maxUnrob = Math.Max(maxUnrob, unrob);        }        return Math.Max(rob, unrob);    }

优化(少一个变量)

public int Rob(int[] nums)     {        int n = nums.Length;        if (n == 0)            return 0;        int maxRob = nums[0], maxUnrob = 0,tmp;        for (int i = 1; i < n; i++)        {            tmp = maxRob;            maxRob = Math.Max(maxRob, nums[i] + maxUnrob);            maxUnrob = Math.Max(maxUnrob, tmp);        }        return Math.Max(maxRob, maxUnrob);    }

递归式 dp[i] = Math.Max(dp[i - 1], dp[i - 2] + nums[i])

public int Rob(int[] nums)     {        int n = nums.Length;        if (n == 0)            return 0;        if (n == 1)            return nums[0];        int prepre = nums[0];        int pre = Math.Max(nums[0], nums[1]);        int res = pre;        for (int i = 2; i < n; i++)        {            res = Math.Max(pre, prepre + nums[i]);            prepre = pre;            pre = res;        }        return res;    }


213 https://leetcode.com/problems/house-robber-ii/

在198题的基础上,nums数组变成一个环

情况1 rob nums[0],然后加上nums[2]-nums[n-1]之间最大rob

情况2 unrob nums[0],直接求nums[1]-nums[n]之间最大rob

public class Solution {    public int Rob(int[] nums)    {        int n = nums.Length;        if (n == 0)            return 0;        if (n == 1)            return nums[0];        int max01= Math.Max(nums[0], nums[1]);        if (n == 2)            return max01;        if (n == 3)            return Math.Max(max01, nums[2]);        return Math.Max(nums[0] + Func(nums, n - 3,2), Func(nums, n - 1,1));    }         private int Func(int[] nums, int n,int start)    {        if (n == 1)            return nums[start];        int prepre = nums[start];        int pre = Math.Max(nums[start], nums[start+1]);        int res = pre;        for (int i = 2; i < n; i++)        {            res = Math.Max(pre, prepre + nums[start+i]);            prepre = pre;            pre = res;        }        return res;    }}


0 0
原创粉丝点击